<?xml version="1.0"?>
<!-- $Id: html-transformer.xslt,v 1.4 2004/11/08 17:56:18 cvsuser Exp $ -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>

    <!-- main transformation -->
    <xsl:template match="benchmark">
        <html>
            <head>
                <title>Benchmarking results of <xsl:value-of select="current()/xml-file"/></title>
            </head>
            <body>
                <h1>Benchmark Results</h1>

Produced by Benchmark Utility<br/>
Created by:<br/>
Vassilios Karakoidas (bkarak@aueb.gr) - http://istlab.dmst.aueb.gr/~bkarak/<br/>
Diomidis Spinellis (dds@aueb.gr) - http://www.spinellis.gr/<br/><br/>
                <b>XML File: </b>
                <xsl:value-of select="current()/xml-file"/>
                <br/>
		<!-- Iterations -->
                <xsl:if test="count(current()/iteration-result) != 0">
                    <h3>Iteration Benchmarks</h3>
                    
		    <xsl:apply-templates select="current()/iteration-result"/>
                </xsl:if>
		<!-- Compile Iterations -->
                <xsl:if test="count(current()/compile-iteration-result) != 0">
                    <h3>Compile Iteration Benchmarks</h3>
                    
		    <xsl:apply-templates select="current()/compile-iteration-result"/>
                </xsl:if>
		<!-- Compatibility -->
                <xsl:if test="count(current()/compatibility-result) != 0">
                    <h3>Compatibility Tests</h3>
                    <table border="1" cellspacing="0">
                        <tr>
                            <td><b>Engines</b></td>
                            <xsl:for-each select="current()/compatibility-result/engine-list/engine">
                                <td><b><xsl:value-of select="current()" /></b></td>
                            </xsl:for-each>
                        </tr>
                        <xsl:apply-templates select="current()/compatibility-result/data-set"/>
                    </table>
                </xsl:if>
            </body>
        </html>
    </xsl:template>

    <!-- compile iteration -->
    <xsl:template match="compile-iteration-result">
    	<table border="1" cellspacing="0">
        <tr>
            <td colspan="2">
            <b>Regular Expression:</b><code><xsl:value-of select="current()/regex"/></code><br/>
            <b>Data:</b><code><xsl:value-of select="current()/data"/></code><br/>
            <b>Count:</b><code><xsl:value-of select="current()/count"/></code>
            </td>
        </tr>
        <xsl:for-each select="current()/engine">
            <tr>
                <td><b><xsl:value-of select="name"/></b></td>
                <td><xsl:value-of select="time"/>  msecs</td>
            </tr>
        </xsl:for-each>
	</table>
	<br />
    </xsl:template>
    
    <!-- iteration -->
    <xsl:template match="iteration-result">
    	<table border="1" cellspacing="0">
        <tr>
            <td colspan="2">
            <b>Regular Expression:</b><code><xsl:value-of select="current()/regex"/></code><br/>
            <b>Data:</b><code><xsl:value-of select="current()/data"/></code><br/>
            <b>Count:</b><code><xsl:value-of select="current()/count"/></code>
            </td>
        </tr>
        <xsl:for-each select="current()/engine">
            <tr>
                <td><b><xsl:value-of select="name"/></b></td>
                <td><xsl:value-of select="time"/>  msecs</td>
            </tr>
        </xsl:for-each>
	</table>
	<br />
    </xsl:template>

    <!-- compatibility -->
    <xsl:template match="data-set">
        <tr>
            <td>
	    Regex:<code><xsl:value-of select="current()/regex"/></code><br/>
            Data:<code><xsl:value-of select="current()/data"/></code>
            </td>
	    <xsl:for-each select="current()/compatible">
            <td>
	    	<center>
		<xsl:if test="contains('pass',current())">
			<font color="#0000FF"><xsl:value-of select="current()"/></font>
		</xsl:if>
	    	<xsl:if test="contains('fail',current())">
			<font color="#FF0000"><xsl:value-of select="current()"/></font>
		</xsl:if>
		</center>
            </td>	    
	    </xsl:for-each>
        </tr>
    </xsl:template>

</xsl:stylesheet>
