<?xml version="1.0"?>
<!-- $Id: latex-transformer.xslt,v 1.5 2004/11/08 17:56:18 cvsuser Exp $ -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="text" />

    <!-- main transformation -->
    <xsl:template match="benchmark">
\documentclass[a4paper,12pt,titlepage]{article}

\usepackage{amsfonts,amssymb,amsbsy,amsmath}
\usepackage{pifont}

\begin{document}

\begin{titlepage}
\begin{center}
	\small{
        SENSE - Software Engineering and Security Lab

        Department of Management Science and Technology

		Athens University of Economics and Business\\
	}
	\vspace{4cm}
	\huge{Benchmark Results\\ File: <xsl:value-of select="current()/xml-file" />} \\
	\vspace{5cm}
	\normalsize
	\textbf{Vassilios Karakoidas (bkarak@aueb.gr)\\ Diomidis Spinellis (dds@aueb.gr)\\}
    \vspace{1cm}
    \today
\end{center}
\end{titlepage}

<xsl:if test="count(/benchmark/iteration-result) != 0">
\section{Iteration Benchmarks}

<xsl:apply-templates select="/benchmark/iteration-result" />
</xsl:if>

<xsl:if test="count(/benchmark/compile-iteration-result) != 0">
\section{Compile Iteration Benchmarks}

<xsl:apply-templates select="/benchmark/compile-iteration-result" />
</xsl:if>

<xsl:if test="count(/benchmark/compatibility-result/data-set) != 0">
\section{Compatibility Tests}

<xsl:apply-templates select="/benchmark/compatibility-result" />

</xsl:if>
\end{document}
	</xsl:template>

	<!-- compile iteration result -->
	<xsl:template match="compile-iteration-result">
\subsection{Iteration Test Information}
\noindent
Regex: \verb%<xsl:value-of select="current()/regex" />% \\
Data: \verb%<xsl:value-of select="current()/data"/>% \\
Count: \verb%<xsl:value-of select="current()/count"/>% \\ \\
\noindent
\begin{tabular}{ c c }
\hline
\small{Engine name} &amp; \small{Elapsed Time (msecs)} \\
\hline
<xsl:for-each select="current()/engine">
\small{<xsl:value-of select="current()/name"/>} &amp; \small{<xsl:value-of select="current()/time"/>} \\
</xsl:for-each>\hline
\end{tabular}
	</xsl:template>
	
	<!-- iteration result -->
	<xsl:template match="iteration-result">
\subsection{Iteration Test Information}
\noindent
Regex: \verb%<xsl:value-of select="current()/regex" />% \\
Data: \verb%<xsl:value-of select="current()/data"/>% \\
Count: \verb%<xsl:value-of select="current()/count"/>% \\ \\
\noindent
\begin{tabular}{ c c }
\hline
\small{Engine name} &amp; \small{Elapsed Time (msecs)} \\
\hline
<xsl:for-each select="current()/engine">
\small{<xsl:value-of select="current()/name"/>} &amp; \small{<xsl:value-of select="current()/time"/>} \\
</xsl:for-each>\hline
\end{tabular}
	</xsl:template>

	<!-- Compatibility Result -->
	<xsl:template match="compatibility-result">
\begin{tabular}{ p{2.0cm} <xsl:for-each select="current()/engine-list/engine"> c </xsl:for-each>}
\hline
<xsl:text> </xsl:text><xsl:for-each select="current()/engine-list/engine"> &amp; \scriptsize{<xsl:value-of select="current()"/>}</xsl:for-each> \\
\hline
<xsl:for-each select="current()/data-set">
\scriptsize{Regex: \verb%<xsl:value-of select="current()/regex"/>%}<xsl:for-each select="compatible"> &amp; <xsl:if test="contains(current(),'pass')">\checkmark</xsl:if><xsl:if test="contains(current(),'fail')">\ding{55}</xsl:if></xsl:for-each> \\
</xsl:for-each>
\hline
\end{tabular}
	</xsl:template>

</xsl:stylesheet>