<?xml version="1.0"?>
<!-- $Id: text-transformer.xslt,v 1.4 2004/11/08 17:56:18 cvsuser Exp $ -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="text" />

    <!-- main transformation -->
    <xsl:template match="benchmark">
Benchmark Results

Produced by Benchmark Utility
Created by:
Vassilios Karakoidas (bkarak@aueb.gr) - http://istlab.dmst.aueb.gr/~bkarak/
Diomidis Spinellis (dds@aueb.gr) - http://www.spinellis.gr/

XML File:<xsl:value-of select="current()/xml-file" />

<xsl:if test="count(current()/iteration-result) != 0">
Iteration Benchmarks

<xsl:apply-templates select="current()/iteration-result" />
</xsl:if>

<xsl:if test="count(current()/compile-iteration-result) != 0">
Compile Iteration Benchmarks

<xsl:apply-templates select="current()/compile-iteration-result" />
</xsl:if>

<xsl:if test="count(current()/compatibility-result/data-set) != 0">
Compatibility Tests
<xsl:apply-templates select="current()/compatibility-result" />
</xsl:if>
    </xsl:template>
    
    <!-- Compile Iterations -->
    <xsl:template match="compile-iteration-result">
------------------
Regex: <xsl:value-of select="current()/regex" />
 Data: <xsl:value-of select="current()/data" />
Count: <xsl:value-of select="current()/count"/>
Results:
<xsl:for-each select="current()/engine">
<xsl:value-of select="current()/name" /> - <xsl:value-of select="current()/time" /> msecs
</xsl:for-each>------------------
    </xsl:template>

    <!-- Iterations -->
    <xsl:template match="iteration-result">
------------------
Regex: <xsl:value-of select="current()/regex" />
 Data: <xsl:value-of select="current()/data" />
Count: <xsl:value-of select="current()/count"/>
Results:
<xsl:for-each select="current()/engine">
<xsl:value-of select="current()/name" /> - <xsl:value-of select="current()/time" /> msecs
</xsl:for-each>------------------
    </xsl:template>
    
    <!-- -->
    <xsl:template match="compatibility-result">
<xsl:for-each select="current()/data-set">
------------------
Regex: <xsl:value-of select="regex"/>
 Data: <xsl:value-of select="data" />
Results:
<xsl:for-each select="/benchmark/compatibility-result/engine-list/engine">
<xsl:value-of select="current()"/><xsl:text> </xsl:text>
</xsl:for-each>
<xsl:text>
</xsl:text>
<xsl:for-each select="current()/compatible">
	<xsl:value-of select="current()" /><xsl:text> </xsl:text>
</xsl:for-each>
</xsl:for-each>
------------------
    </xsl:template>

</xsl:stylesheet>
